//
// C++ Interface: konstdef
//
// Description: 
//
//
// Author: Andreas Lindenau <DL4JAL@darc.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
// * Edit dc5pi, 2016-03-24 /dev/ttypACM[0:3]
//
#ifndef KONSTDEF_H
#define KONSTDEF_H
#if QT_VERSION >= 0x050000
#include <QtWidgets>
#else
#include <QtGui>
#endif
#include <QtCore>
//#include <QPen>
//#include <QColor>
//#include <QDir>
//#include <QPoint>



const int maxmesspunkte = 2000+1; // Messpunkte von 0 - 2001 = 2000 Frequenzabschnitte
const int maxrxbuffer = 200000; // RS232 Buffer maximale Laenge

const char schnittstelle1[] ="/dev/ttyS0";
const char schnittstelle2[] ="/dev/ttyS1";
const char schnittstelle3[] ="/dev/ttyS2";
const char schnittstelle4[] ="/dev/ttyS3";
const char schnittstelle5[] ="/dev/ttyUSB0";
const char schnittstelle6[] ="/dev/ttyUSB1";
const char schnittstelle7[] ="/dev/ttyUSB2";
const char schnittstelle8[] ="/dev/ttyUSB3";
const char schnittstelle9[] ="/dev/ttyACM0";
const char schnittstelle10[]="/dev/ttyACM1";
const char schnittstelle11[]="/dev/ttyACM2";
const char schnittstelle12[]="/dev/ttyACM3";

typedef struct {
  QDir  homedir;//Verzeichnis aller wichtigen Dateien
  QColor colorhintergrund;
  QColor colorschrift;
  QColor colormarkerschrift;
  QColor colorliniek1;
  QColor colorliniek2;
  double maxddsfrequenz;//maximale DDS Frequenz
  double ddstakt;//Takt des DDS ICs
  double svfofrq;//Frequenz zum Kalibrieren der Taktfrequenz
  double pegel10mhz;//Output der HW in dBm
  double vfofrqgang[maxmesspunkte];//Frequenzgang der HW DDS 100kHz bis 200Mhz
  QString filevfofrqgang;//Dateiname der Frequenzgangdatei
  bool bvfofrqgang;//gueltiger Frequenzgang steuert Buttonfarbe im SETUP
  int hangk1;//Peak&Hold Zeit mW-Meter Messkanal1
  int hangk2;//Peak&Hold Zeit mW-Meter Messkanal2
}TGrunddaten;

typedef struct {
  bool aktiv[16];
  double frq1[16];
  double frq2[16];
  QString caption[16];
}TFrqmarken;

typedef struct{
  QString caption;//Beschreibung der Kurve
  QPoint point;//Point für senkrechten Strich an Mousezeiger
  int steps;//Anzahl der Frequenzschritte
  double shift1;//Verschiebung der Kurve Y-Achse
  double shift2;//Verschiebung der Kurve Y-Achse
  double frequenz[maxmesspunkte];//Frequenz des Messpunktes
  double dbk1[maxmesspunkte];//db Wert Kanal1
  double dbk2[maxmesspunkte];//db Wert Kanal2
  double swrk1[maxmesspunkte];//SWR Wert Kanal1
  double swrk2[maxmesspunkte];//SWR Wert Kanal2
  bool bdelta;//Deltaanzeige Kanal1 und Kanal2 in dB EIN/AUS
  bool bswr1;//SWR Kanal1 Anzeige EIN/AUS
  bool bswr2;//SWR Kanal2 Anzeige EIN/AUS
  bool bkanal1;//Kanal1 EIN/AUS
  bool bkanal2;//Kanal2 EIN/AUS
  bool bdbmax1;//dbmaxanzeige EIN/AUS
  bool bdbmin1;//dbminanzeige EIN/AUS
  bool b3db1;//3dB Bandbreite EIN/AUS
  bool bguete1;//3dB Bandbreite EIN/AUS
  double frq3db11;//3dB Bandbreite untere Frequenz
  double frq3db21;//3dB Bandbreite obere Frequenz
  bool b6db1;//6dB Bandbreite EIN/AUS
  double frq6db11;//6dB Bandbreite untere Frequenz
  double frq6db21;//3dB Bandbreite obere Frequenz
  bool b60db1;//60dB Bandbreite EIN/AUS
  bool bshape1;//60dB Bandbreite EIN/AUS
  double frq60db11;//60dB Bandbreite untere Frequenz
  double frq60db21;//3dB Bandbreite obere Frequenz
  bool bdbmax2;//dbmaxanzeige EIN/AUS
  bool bdbmin2;//dbminanzeige EIN/AUS
  bool b3db2;//3dB Bandbreite EIN/AUS
  bool bguete2;//3dB Bandbreite EIN/AUS
  double frq3db12;//3dB Bandbreite untere Frequenz
  double frq3db22;//3dB Bandbreite obere Frequenz
  bool b6db2;//6dB Bandbreite EIN/AUS
  double frq6db12;//6dB Bandbreite untere Frequenz
  double frq6db22;//3dB Bandbreite obere Frequenz
  bool b60db2;//60dB Bandbreite EIN/AUS
  bool bshape2;//60dB Bandbreite EIN/AUS
  double frq60db12;//60dB Bandbreite untere Frequenz
  double frq60db22;//3dB Bandbreite obere Frequenz
  bool bkurvegueltig;//Messkurve ist gueltig
}TMessKurve;

typedef struct{
  QString caption;//Beschreibung der Kurve
  int steps;//Anzahl der Frequenzschritte
  double frequenz[maxmesspunkte];//Frequenz des Messpunktes
  double db[maxmesspunkte];//db Wert Kanal1
  bool bkanal;//Kanal1 EIN/AUS
}THMessKurve;

typedef struct{
  int schritte;
  double frequenzschritt;
  double frequenzanfang;
  double dbmin;
  double dbmax;
  double dbline;
}TWobbelGrundDaten;

typedef struct{
  QString sstart;
  QString sstop;
  QString ssteps;
  QString sstep;
  QString scenter;
  QString sspan;
  bool banfende;
  bool bspanmitte;
}TWobbelFrqStr;

enum emktyp {mklog, mklin, mklognf};

#endif
