#include <QtGui>
#include <QtCore>


#include "nwt2fwloader.h"
#include "configfile.h"

NWT2fwloader::NWT2fwloader(){
  //ui(new Ui::nwt2fwloader);

  ui.setupUi(this);
  /*****************************************************************************/
  picmodem = new Modem();
  /*****************************************************************************/
  version=0;//FW Version
  variante=0;//FW Variante an HW angepasst
  bd=false;

#ifdef Q_WS_WIN
  int i;
  QString qs;
  for(i=1;i<=50;i++){
    qs.sprintf("COM%i",i);
    listtty.append(qs);
  }
#else
  listtty.append(schnittstelle1);// /dev/ttyS0 Test mit NWT01
  listtty.append(schnittstelle5);// USB Schnittstellen
  listtty.append(schnittstelle6);
  listtty.append(schnittstelle7);
  listtty.append(schnittstelle8);
#endif
  idtty = 0; //mit Index 0 HW-Suche beginnen


  for(int i=0;i<65000;i++)rom[i]=0xff;
  ui.pushButton->setEnabled(false);
  ui.pushButton_2->setEnabled(false);
  openttytimer = new QTimer(this);
  QObject::connect(openttytimer, SIGNAL(timeout()), this, SLOT(fopentty() ));

  QSettings settings("AFU", "QRPWatt");
  fontsize = settings.value("fontsize", 12).toInt();
  //qDebug()<<fontsize;
  if(fontsize<8)fontsize=12;
  QFont fontapp = this->font();
  fontapp.setPixelSize(fontsize);
  fontapp.setBold(false);
  this->setFont(fontapp);


  picmodem->closetty();
  picmodem->modemspeed(57600);
  if(!rs232isopen)rs232isopen = picmodem->opentty(srs232);
  if(rs232isopen){
    clrrxbuffer();
    picmodem->writeLine("@v;");
    bvantwort = true;
  }
  openttytimer->start(200); //des Geraetes

}

NWT2fwloader::~NWT2fwloader()
{
  QSettings settings("AFU", "QRPWatt");
  settings.setValue("fontsize",fontsize);
  settings.sync();
}

void NWT2fwloader::on_pushButton_clicked()
{
  QString zeile;
  QDir dir=QDir::home();
  QStringList hexlist;
  int anzahl=0, addr=0, typ=0, i=0, byte=0, crc=0;
  long erwaddr=0xffff;
  bool ok;
#ifdef Q_WS_WIN
  dir.setPath(QDir::currentPath());
  dir.cd("qrpwattfw");
#else
  dir.setPath(QDir::homePath());
#endif

  QString s2 = tr("HEX-Datei (*.hex)","FileDialog");
  QString s1 = "*.hex";
  QString s = QFileDialog::getOpenFileName(this, tr("HEX-Datei Laden","FileDialog"),
                                           dir.filePath(s1), s2);
  QFile f;
  if(s.isEmpty()){
    ui.label->setText("HEX-Datei Laden, Abbruch!");
    QPalette palette=ui.label->palette();
    palette.setColor(QPalette::WindowText, Qt::red);
    ui.label->setPalette(palette);
  }else{
    //qDebug()<<s;
    f.setFileName(dir.filePath(s));
    if(f.open(QIODevice::ReadOnly)){
      QTextStream ts(&f);
      do{
        ts >> zeile;
        hexlist.append(zeile);
        //qDebug()<<zeile;
      }while(!zeile.isNull());
      f.close();
    }
    //qDebug()<<hexlist.count();

    hexlist.begin();
    for(int k=0;k<hexlist.size();k++){
      zeile=hexlist.at(k);
      //qDebug()<<zeile;
      crc=0;
      if(zeile.left(1)== ":"){
        s1=zeile.mid(1,2);
        anzahl=0;
        i=s1.toInt(&ok,16);//hex
        if(ok)anzahl=i;
        //qDebug()<<anzahl;
        s1=zeile.mid(3,4);
        addr=0;
        i=s1.toInt(&ok,16);//hex
        if(ok)addr=i;
        s1=zeile.mid(7,2);
        typ=0;
        i=s1.toInt(&ok,16);//hex
        if(ok)typ=i;
        if(typ==4){
          s1=zeile.mid(9,4);
          long l=s1.toLong(&ok,16);
          if(ok)erwaddr=l;
        }
        if(typ==0 and erwaddr==0){
          for(int j=0;j<anzahl;j++){
            s1=zeile.mid(9+j*2,2);
            //qDebug()<<s1;
            i=s1.toInt(&ok,16);//hex
            if(ok)byte=i;
            rom[addr]=byte;
            //qDebug("addr:%04X byte:%02X",addr,byte);
            addr++;
          }
          romaddr=addr-1;
        }
      }
    }
    if(rom[0x20]==0 and rom[0x21]==0xef and rom[0x22]==0x7e and rom[0x23]==0xf0 and romaddr < 0xfc00){
      ui.pushButton_2->setEnabled(true);
      s1.sprintf("HEX-Datei OK!! Laenge: %li Byte", romaddr);
      ui.label->setText(s1);
      QPalette palette=ui.label->palette();
      palette.setColor(QPalette::WindowText, Qt::darkGreen);
      ui.label->setPalette(palette);
    }else{
      ui.label->setText("HEX-Datei nicht geeignet!!");
      QPalette palette=ui.label->palette();
      palette.setColor(QPalette::WindowText, Qt::red);
      ui.label->setPalette(palette);
    }
  }
}

void NWT2fwloader::fopentty(){
  int gelesen;
  QString qs;
  QString qversion;

  if(bd)qDebug("nwt2fwloader::fopentty");
  openttytimer->stop();
  if(bvantwort){
    bvantwort = false;
    gelesen = picmodem->readttybuffer(rxbuffer, 8);
    if(gelesen == 8){
      geraet=rxbuffer[2];
      geraet.append(rxbuffer[3]);
      qversion=rxbuffer[4];
      qversion.append(rxbuffer[5]);
      qversion.append(rxbuffer[6]);
      version = qversion.toInt();
      bvantwort = false;
      //qDebug(qPrintable(geraet));
      qDebug("Version: %03i", version);
      if((geraet == "QW")and(version >= 100)){
        bnwtgefunden = true;
        openttytimer->stop(); //Suchen der Schnittstelle bendet
        statusBar()->showMessage(tr("HW gefunden an: ") + srs232);
        qs.sprintf("FW: V%i.%02i",version/100,version-100);
        ui.label_3->setText(qs);
        ui.pushButton->setEnabled(true);
      }else{
        idtty++;
        if(idtty > (listtty.count()-1))idtty = 0;
        openttytimer->start(200); //Suchen der Schnittstelle
        picmodem->closetty();
        rs232isopen = false;
      }
    }else{
      idtty++;
      if(idtty > (listtty.count()-1))idtty = 0;
      openttytimer->start(200); //Suchen der Schnittstelle
      picmodem->closetty();
      rs232isopen = false;
    }
  }else{
    if(!rs232isopen){
      srs232 = listtty.at(idtty);
      statusBar()->showMessage("Suche HW :" + srs232);
      //qDebug(qPrintable(srs232));
      //qDebug("%i",idtty);
      rs232isopen = picmodem->opentty(srs232);
      if(rs232isopen){
        clrrxbuffer();
        picmodem->writeLine("@v;");
        //qDebug("open");
        bvantwort = true;
        openttytimer->start(300); //Suchen der HW
      }else{
        idtty++;
        if(idtty > (listtty.count()-1))idtty = 0;
        openttytimer->start(100); //Suchen der Schnittstelle
        bvantwort = false;
        picmodem->closetty();
      }
    }
  }
  if(bd)qDebug("nwt2fwloader::fopentty ENDE");
}

void NWT2fwloader::clrrxbuffer(){
  char abuffer[maxmesspunkte*4];

  if (rs232isopen){
    picmodem->readttybuffer(abuffer, maxmesspunkte*4);//PC Buffer maximal auslesen
  }
  for(int i=0;i<maxmesspunkte*4;i++)rxbuffer[i]=0; //rs232buffer loeschen
}

void NWT2fwloader::on_pushButton_2_clicked()
{
  long addr=0;
  int gelesen=0;
  int block=0, blockall=0;
  char abuffer[10];
  unsigned char byteL, byteH;
  QString s;

  blockall=romaddr/64+1;
  picmodem->writeLine("@g#####;");//Befehl zum Flashschreiben geben
  statusBar()->showMessage(tr("Flash schreiben starten, bitte warten!"));
  if(rs232isopen){
    clrrxbuffer();
    while(addr<romaddr){
      do{
        gelesen=picmodem->readttybuffer(abuffer, 1);
        if(gelesen==1){
          //qDebug()<<gelesen;
          //qDebug()<<abuffer;
          block++;
          s.sprintf("Block: %i / %i", block, blockall);
          ui.label_2->setText(s);
          qApp->processEvents();
        }
      }while(gelesen==0);
      statusBar()->showMessage(tr("Flash wird beschrieben!"));
      qApp->processEvents();
      if(abuffer[0]=='k'){
        byteH = addr / 256;
        byteL = addr - (byteH*256);
        picmodem->writeChar(byteL);
        picmodem->writeChar(byteH);
        for(int i=0;i<64;i++){
          picmodem->writeChar(rom[addr]);
          addr++;
        }
      }
    }
    byteL=0xff;
    byteH=0xff;
    picmodem->writeChar(byteL);
    picmodem->writeChar(byteH);
    //qDebug("%X %X", byteL, byteH);
    s.sprintf("Block: %i / %i", block, blockall);
    ui.label_2->setText(s);
    qApp->processEvents();
  }
  statusBar()->showMessage(tr("Flash neu beschrieben!"));
  QPalette palette=ui.label_2->palette();
  palette.setColor(QPalette::WindowText, Qt::darkGreen);
  ui.label_2->setPalette(palette);
  ui.label_3->setText("FW: neu, Exit Programm");
}

void NWT2fwloader::on_pushButton_3_clicked()
{
  close();
}
