#ifndef NWT2FWLOADER_H
#define NWT2FWLOADER_H

#if QT_VERSION >= 0x050000
#include <QtWidgets>
#else
#include <QtGui>
#endif
#include <QtCore>

#include "konstdef.h"
#include "ui_nwt2fwloader.h"

#ifdef Q_WS_WIN
#include "win_modem.h"
#else
#include "lin_modem.h"
#endif

class NWT2fwloader: public QMainWindow{
  Q_OBJECT

public:
  NWT2fwloader();
  ~NWT2fwloader();

private:
  Ui::QwFWloader ui;

  int rom[65000];//ROM des PIC
  long romaddr;//Adresse im PIC

  Modem *picmodem;
  QString srs232;
  bool rs232isopen;
  QTimer *openttytimer;
  QStringList listtty;
  int idtty;
  bool bvantwort;
  bool bnwtgefunden;
  QString geraet;
  int version;
  int variante;
  int fontsize;
  bool bd;
  char rxbuffer[maxmesspunkte*4]; //maximale Anzahl

  void clrrxbuffer();

private slots:
  void on_pushButton_clicked();
  void fopentty();

  void on_pushButton_2_clicked();
  void on_pushButton_3_clicked();
};

#endif // NWT2FWLOADER_H
